/*
 * $Id: window.c,v 1.5 2004/12/30 09:07:47 ali Exp $
 * Copyright (C) 2007 J. Ali Harlow
 * Min Hack may be freely redistributed.  See license for details. 
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "minhack.h"

int message_win=-1;
int map_win=-1;

int minhack_create_nhwindow(int type)
{
    int window;
    for(window=0;window<no_windows;window++)
	if (!windows[window].in_use)
	    break;
    if (window==no_windows)
	windows=realloc(windows,++no_windows*sizeof(*windows));
    windows[window].in_use=nhproxy_true;
    windows[window].type=type;
    windows[window].menu=NULL;
    switch(type)
    {
	case NHPROXY_EXT_NHW_MESSAGE:
	    windows[window].win=newwin(1,0,0,0);
	    if (message_win<0)
		message_win=window;
	    break;
	case NHPROXY_EXT_NHW_STATUS:
	    windows[window].win=newwin(2,0,LINES-2,0);
	    break;
	case NHPROXY_EXT_NHW_MAP:
	    if (map_win<0)
		map_win=window;
	    /* Fall through */
	case NHPROXY_EXT_NHW_MENU:
	case NHPROXY_EXT_NHW_TEXT:
	    windows[window].win=NULL;
	    break;
    }
    return window;
}

void minhack_clear_nhwindow(int window, int rows, int cols, int layers)
{
    if (windows[window].type==NHPROXY_EXT_NHW_MAP)
    {
	if (windows[window].win)
	    delwin(windows[window].win);
	windows[window].win=newwin(rows,cols,1,0);
    }
    else
	werase(windows[window].win);
}

void minhack_display_nhwindow(int window, nhproxy_bool_t blocking)
{
    wrefresh(windows[window].win);
}

void minhack_destroy_nhwindow(int window)
{
    minhack_free_menu(window);
    if (windows[window].win)
    {
	delwin(windows[window].win);
	windows[window].win=NULL;
    }
    if (window==message_win)
	message_win=-1;
    else if (window==map_win)
	map_win=-1;
    windows[window].in_use=nhproxy_false;
}
